
#include "gfx_box.h"
#include "lump_area.h"

class GfxLumpArea : public LumpArea
{
private:
	wxImage		image;
	GfxBox		*draw_area;
	wxColour*	palette;
	bool		change;

	//wxToolBar	*toolbar;
	wxButton	*btn_zoomin;
	wxButton	*btn_zoomout;
	wxTextCtrl	*entry_xoff;
	wxTextCtrl	*entry_yoff;
	wxChoice	*combo_offtype;

public:
	enum
	{
		GA_BTN_ZOOMIN,
		GA_BTN_ZOOMOUT,
		GA_ENTRY_XOFF,
		GA_ENTRY_YOFF,
		GA_COMBO_OFFTYPE,
	};

	GfxLumpArea(wxWindow *parent, wxColour* palette);
	~GfxLumpArea();

	virtual void loadLump(Lump* lump);
	virtual void checkSave();

	void readPatch();
	void readFlat();

	void savePatch();
	void savePNG();

	void onZoomIn(wxCommandEvent &event);
	void onZoomOut(wxCommandEvent &event);
	void onXOffChanged(wxCommandEvent &event);
	void onYOffChanged(wxCommandEvent &event);
	void onOffTypeChanged(wxCommandEvent &event);

	DECLARE_EVENT_TABLE()
};
