
#include "lump_area.h"

struct patch_info_t
{
	short	xoff;
	short	yoff;
	string	patch;
};

struct texture_t
{
	short					width;
	short					height;
	string					name;
	vector<patch_info_t>	patches;
};

class TextureArea : public wxPanel
{
private:
	texture_t*					texture;
	wxColour					*palette;
	vector<wxImage*>			images;
	Wad*						wadfile;
	int							sel_patch;

public:
	TextureArea(wxWindow *parent, wxColour *palette, Wad *wadfile);
	~TextureArea();

	void setTexture(texture_t* tex);
	void selPatch(int p) { sel_patch = p; }

	void paint(wxPaintEvent &event);

	DECLARE_EVENT_TABLE()
};

class TextureLumpArea : public LumpArea
{
private:
	wxListBox			*list_textures;
	wxListBox			*list_pnames;
	wxListBox			*list_patches;
	TextureArea			*ta_texture;

	vector<texture_t>	textures;
	vector<string>		pnames;
	Wad					*wadfile;

public:
	enum
	{
		TLA_LIST_TEXTURES,
		TLA_LIST_PATCHES,
	};

	TextureLumpArea(wxWindow *parent, wxColour *palette, Wad* wadfile);
	~TextureLumpArea();

	virtual void loadLump(Lump* lump);
	virtual void checkSave();

	void onTextureListChange(wxCommandEvent &event);
	void onPatchesListChange(wxCommandEvent &event);

	DECLARE_EVENT_TABLE()
};
